function varargout = wavelet_construct_time_history(varargin)
% WAVELET_CONSTRUCT_TIME_HISTORY MATLAB code for wavelet_construct_time_history.fig
%      WAVELET_CONSTRUCT_TIME_HISTORY, by itself, creates a new WAVELET_CONSTRUCT_TIME_HISTORY or raises the existing
%      singleton*.
%
%      H = WAVELET_CONSTRUCT_TIME_HISTORY returns the handle to a new WAVELET_CONSTRUCT_TIME_HISTORY or the handle to
%      the existing singleton*.
%
%      WAVELET_CONSTRUCT_TIME_HISTORY('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in WAVELET_CONSTRUCT_TIME_HISTORY.M with the given input arguments.
%
%      WAVELET_CONSTRUCT_TIME_HISTORY('Property','Value',...) creates a new WAVELET_CONSTRUCT_TIME_HISTORY or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before wavelet_construct_time_history_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to wavelet_construct_time_history_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help wavelet_construct_time_history

% Last Modified by GUIDE v2.5 15-Oct-2015 16:18:41

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @wavelet_construct_time_history_OpeningFcn, ...
                   'gui_OutputFcn',  @wavelet_construct_time_history_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before wavelet_construct_time_history is made visible.
function wavelet_construct_time_history_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to wavelet_construct_time_history (see VARARGIN)

% Choose default command line output for wavelet_construct_time_history
handles.output = hObject;

set(handles.uipanel_save,'Visible','off');

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes wavelet_construct_time_history wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = wavelet_construct_time_history_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton_return.
function pushbutton_return_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_return (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

delete(wavelet_construct_time_history);


% --- Executes on button press in pushbutton_calculate.
function pushbutton_calculate_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_calculate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

fig_num=1;

tpi=2*pi;

try  
    FS=get(handles.edit_input_array,'String');
    THF=evalin('base',FS);  
    iflag=1;
catch
    iflag=0; 
    warndlg('Input Array does not exist.  Try again.')
end

iform=get(handles.listbox_format,'Value');

iu=get(handles.listbox_iu,'Value');

if(iu==1)
    vscale=386;
    dscale=386;    
    aname='Accel (G)';
    vname='Vel (in/sec)';
    dname='Disp (in)';
end
if(iu==2)
    vscale=9.81;
    dscale=9.81*1000;
    aname='Accel (G)';
    vname='Vel (m/sec)';
    dname='Disp (mm)';    
end
if(iu==3)
    vscale=1;
    dscale=9.81*1000; 
    aname='Accel (m/sec^2)';
    vname='Vel (m/sec)';
    dname='Disp (mm)';    
end

%
sz=size(THF);
last_wavelet=sz(1);
ncol=sz(2);

if(iform==1 || iform==2)
    if(ncol~=5)
        warndlg('Input error. Number of columns is incorrect.'); 
        return;
    end
end
if(iform==3 || iform==4)
    if(ncol~=4)
        warndlg('Input error. Number of columns is incorrect.'); 
        return;
    end
end

%
if(iform==1)
    f=THF(:,2);
    amp=THF(:,3);
end
if(iform==2)
    amp=THF(:,2);
    f=THF(:,3);
end
if(iform==3)
    f=THF(:,1);
    amp=THF(:,2);
end
if(iform==4)
    amp=THF(:,1);
    f=THF(:,2);
end
%

if(iform==1 || iform==2)
    NHS=THF(:,4);
    td=THF(:,5);
end
if(iform==3 || iform==4)
    NHS=THF(:,3);
    td=THF(:,4);
end

%

if(min(f)<0)
    warndlg(' Frequency input error. Negative frequency.  Check format. ');
    return;
end

dur=str2num(get(handles.edit_duration,'String'));
delay=str2num(get(handles.edit_delay,'String'));
sr=str2num(get(handles.edit_sr,'String'));

maxf=max(f);

nr=24;

if(sr<nr*maxf)
    sr=nr*maxf;
    out1=sprintf('Sample rate reset to %8.4g Hz',sr);    
    msgbox(out1); 
    out2=sprintf('%9.5g',sr);
    set(handles.edit_sr,'String',out2);
end


dt=1/sr;

beta=tpi*f;

alpha=zeros(last_wavelet,1);
upper=zeros(last_wavelet,1);

wavelet_low=zeros(last_wavelet,1);
wavelet_up=zeros(last_wavelet,1);

tmax=0;

for i=1:last_wavelet
    alpha(i)=beta(i)/double(NHS(i));
    te=(NHS(i)/(2.*f(i)));
    upper(i)=td(i)+te;
    if(te>tmax)
        tmax=te;
    end
end

if(tmax>dur)
    dur=1.05*tmax;
    out1=sprintf('Duration reset to %8.4g sec',dur);    
    msgbox(out1); 
    out2=sprintf('%8.4g',dur);
    set(handles.edit_duration,'String',out2);    
end

nt=ceil(dur/dt);



for i=1:last_wavelet
%    
    wavelet_low(i)=round( 0.5 +   (td(i)/dur)*nt);
     wavelet_up(i)=round(-0.5 +(upper(i)/dur)*nt);   
%    
    if(wavelet_low(i)==0)
        wavelet_low(i)=1;       
    end
    if(wavelet_up(i)>nt)
        wavelet_up(i)=nt;       
    end   
% 
end

%%%

t=linspace(0,nt*dt,nt);  

accel=zeros(nt,1);
velox=zeros(nt,1);
dispx=zeros(nt,1);  

APB=zeros(nt,1);
AMB=zeros(nt,1);

%     
for i=1:last_wavelet       
%
        sa=zeros(nt,1);
        sb=zeros(nt,1);
        sc=zeros(nt,1);
%
        ia=wavelet_low(i);
        ib=wavelet_up(i);
%       
        sa(ia:ib)=sin( alpha(i)*( t(ia:ib)-td(i) ) );
        sb(ia:ib)=sin(  beta(i)*( t(ia:ib)-td(i) ) );
        sc=amp(i)*sa.*sb;
%
		accel(ia:ib)=accel(ia:ib)+sc(ia:ib);
%
end
%
%    
for i=1:last_wavelet    
        APB(i)=alpha(i)+beta(i);
        AMB(i)=alpha(i)-beta(i);
end
%
for i=1:last_wavelet
%
        sa=zeros(nt,1);
        sb=zeros(nt,1);
        sc=zeros(nt,1);  
%
        ia=wavelet_low(i);
        ib=wavelet_up(i);
%
        sa(ia:ib)=sin( APB(i)*( t(ia:ib)-td(i) ) )/APB(i);
        sb(ia:ib)=sin( AMB(i)*( t(ia:ib)-td(i) ) )/AMB(i);
        sc=amp(i)*(-sa+sb)*0.5;
%          
		velox(ia:ib)=velox(ia:ib)+sc(ia:ib);
%				
end

velox=velox*vscale;

%
for i=1:last_wavelet
%
        sa=zeros(nt,1);
        sb=zeros(nt,1);
        sc=zeros(nt,1);  
%
        ia=wavelet_low(i);
        ib=wavelet_up(i);
%
        sa(ia:ib)=(-1+cos(APB(i)*( t(ia:ib)-td(i) ) ))/((APB(i))^2);
        sb(ia:ib)=(-1+cos(AMB(i)*( t(ia:ib)-td(i) ) ))/((AMB(i))^2);
        sc=amp(i)*(sa-sb)*0.5;
%          
		dispx(ia:ib)=dispx(ia:ib)+sc(ia:ib);
%				
end

dispx=dispx*dscale;

t=fix_size(t);
t=t+delay;

acceleration=[t,accel];
    velocity=[t,velox];
displacement=[t,dispx];

setappdata(0,'acceleration',acceleration);
setappdata(0,'velocity',velocity);
setappdata(0,'displacement',displacement);

%%%

figure(1);
plot(t,dispx);
grid on;
title('Displacement');
xlabel('Time (sec)');
ylabel(dname);

%%%

figure(2);
plot(t,velox);
grid on;
title('Velocity');
xlabel('Time (sec)');
ylabel(vname);

%%%

figure(3);
plot(t,accel);
grid on;
title('Acceleration');
xlabel('Time (sec)');
ylabel(aname);


set(handles.uipanel_save,'Visible','on');




% --- Executes on selection change in listbox_format.
function listbox_format_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_format (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox_format contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_format
set(handles.uipanel_save,'Visible','off');

% --- Executes during object creation, after setting all properties.
function listbox_format_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_format (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_input_array_Callback(hObject, eventdata, handles)
% hObject    handle to edit_input_array (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_input_array as text
%        str2double(get(hObject,'String')) returns contents of edit_input_array as a double


% --- Executes during object creation, after setting all properties.
function edit_input_array_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_input_array (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_duration_Callback(hObject, eventdata, handles)
% hObject    handle to edit_duration (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_duration as text
%        str2double(get(hObject,'String')) returns contents of edit_duration as a double


% --- Executes during object creation, after setting all properties.
function edit_duration_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_duration (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_delay_Callback(hObject, eventdata, handles)
% hObject    handle to edit_delay (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_delay as text
%        str2double(get(hObject,'String')) returns contents of edit_delay as a double


% --- Executes during object creation, after setting all properties.
function edit_delay_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_delay (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_sr_Callback(hObject, eventdata, handles)
% hObject    handle to edit_sr (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_sr as text
%        str2double(get(hObject,'String')) returns contents of edit_sr as a double


% --- Executes during object creation, after setting all properties.
function edit_sr_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_sr (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox_iu.
function listbox_iu_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_iu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox_iu contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_iu
set(handles.uipanel_save,'Visible','off');

% --- Executes during object creation, after setting all properties.
function listbox_iu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_iu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_output_array_Callback(hObject, eventdata, handles)
% hObject    handle to edit_output_array (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_output_array as text
%        str2double(get(hObject,'String')) returns contents of edit_output_array as a double


% --- Executes during object creation, after setting all properties.
function edit_output_array_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_output_array (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox_output.
function listbox_output_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_output (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns listbox_output contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_output


% --- Executes during object creation, after setting all properties.
function listbox_output_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_output (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_save.
function pushbutton_save_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

i=get(handles.listbox_output,'Value');

if(i==1)
    data=getappdata(0,'acceleration');
end
if(i==2)
    data=getappdata(0,'velocity');    
end
if(i==3)
    data=getappdata(0,'displacement');    
end

output_name=get(handles.edit_output_array,'String');

assignin('base', output_name, data);

h = msgbox('Save Complete');




% --- Executes on key press with focus on edit_input_array and none of its controls.
function edit_input_array_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to edit_input_array (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
set(handles.uipanel_save,'Visible','off');


% --- Executes on key press with focus on edit_delay and none of its controls.
function edit_delay_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to edit_delay (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
set(handles.uipanel_save,'Visible','off');


% --- Executes on key press with focus on edit_duration and none of its controls.
function edit_duration_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to edit_duration (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
set(handles.uipanel_save,'Visible','off');


% --- Executes on key press with focus on edit_sr and none of its controls.
function edit_sr_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to edit_sr (see GCBO)
% eventdata  structure with the following fields (see MATLAB.UI.CONTROL.UICONTROL)
%	Key: name of the key that was pressed, in lower case
%	Character: character interpretation of the key(s) that was pressed
%	Modifier: name(s) of the modifier key(s) (i.e., control, shift) pressed
% handles    structure with handles and user data (see GUIDATA)
set(handles.uipanel_save,'Visible','off');
